(module trim mzscheme
  (provide trim)  
  (require (lib "match.ss"))
  
  (define (trim dws1 dws2)
    (match (list dws1 dws2)
      [(`((,d1 ,b1 ,a1) ,more1 ...)
         `((,d1 ,b2 ,a2) ,more2 ...))
       (trim (cdr dws1) (cdr dws2))]
      [(`((,d1 ,b1 ,a1) ...)
         `((,d2 ,b2 ,a2) ...))
       (append (reverse 
                (map (λ (d1 b1 a1) `(begin (pop) ,a1))
                     d1
                     b1
                     a1))
               (map (λ (d1 b1 a1) `(begin ,b1 (push (,d1 ,b1 ,a1))))
                    d2
                    b2
                    a2))])))
